part of xwidgetbase;

class XDrawer extends StatelessWidget {
  final String? label;
  final Function? onPressed;
  final GestureTapCallback? onTapLogOutArea;
  final GestureTapCallback? onTapNameApp;
  final Widget? nameApp;
  final String? title;
  final EdgeInsetsGeometry? padding;
  final AlignmentGeometry? alignment;
  final bool? isVisibleLogOut;
  final Color? colorMenu;
  final Color? colorOfLogOutArea;
  final Widget? textOfLogOutArea;
  final Widget? iconOfLogOutAreaText;
  final TextStyle? styleTitle;
  final Widget? itemOfMenu;
  XDrawer({
    this.nameApp,
    this.onTapNameApp,
    this.itemOfMenu,
    this.colorOfLogOutArea,
    this.textOfLogOutArea,
    this.iconOfLogOutAreaText,
    this.isVisibleLogOut,
    this.alignment,
    this.colorMenu,
    this.label,
    this.styleTitle,
    this.title,
    this.padding,
    this.onTapLogOutArea,
    this.onPressed,
  });

  @override
  Widget build(BuildContext context) {
    return Drawer(
        child: Container(
            color: colorMenu ?? Colors.white,
            child: Column(
              children: [
                Expanded(
                  flex: isVisibleLogOut != false ? 1 : 2,
                  child: SingleChildScrollView(
                    child: Column(
                      children: <Widget>[
                        // Container(
                        //   height: 100,
                        //   padding: padding ?? EdgeInsets.all(50),
                        //   child: Column(
                        //     children: <Widget>[
                        //       GestureDetector(onTap: onTapNameApp, child: nameApp),
                        //     ],
                        //   ),
                        // ),
                        Container(
                            padding: EdgeInsets.all(15),
                            child: Column(children: <Widget>[
                              title != ""
                                  ? Container(
                                      alignment: Alignment.center,
                                      margin: EdgeInsets.only(bottom: 10),
                                      child: Text(
                                        title ?? "",
                                        style: styleTitle ?? XStyles.xStyleText(fontSize: 12, colorText: Colors.black, letterSpacing: 1.5),
                                      ))
                                  : Container(),
                              Container(alignment: alignment ?? Alignment.center, child: itemOfMenu),
                            ])),
                        SizedBox(
                          height: 15,
                        ),
                      ],
                    ),
                  ),
                ),
                Visibility(
                  visible: isVisibleLogOut ?? true,
                  child: Expanded(
                    flex: 1,
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.end,
                      children: <Widget>[
                        Container(
                            color: colorOfLogOutArea ?? Colors.grey,
                            child: ListTile(
                              title: textOfLogOutArea ?? Text('Logout', style: XStyles.xStyleText(fontSize: 17, colorText: Colors.black), textAlign: TextAlign.left),
                              trailing: iconOfLogOutAreaText ?? Icon(Icons.power_settings_new, color: Colors.red),
                              onTap: onTapLogOutArea,
                            )),
                        SizedBox(height: MediaQuery.of(context).padding.bottom)
                      ],
                    ),
                  ),
                ),
              ],
            )));
  }
}
